Summary: The Linux kernel (the core of the Linux operating system)

# versioning hell
%define buildsmp 1
%define buildBOOT 0
%define buildenterprise 1
%define sublevel 0
%define kversion 2.4.%{sublevel}
%define pcmciaver 3.1.18
%define ksymoopsver 2.3.4
%define devfsdver 1.3.10
%define ia64version 000823
%define kslnk linux-2.4

# disable build root strip policy
%define __spec_install_post /usr/lib/rpm/brp-compress || :

Name: kernel24
Version: %{kversion}
Release: 0.26
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
Copyright: GPL
Group: System Environment/Kernel
ExclusiveArch: i386 i586 i686
#TUX is still x86-specific
#ExclusiveArch: ia64 i386 i586 i686 alpha sparc sparc64
ExclusiveOS: Linux
Obsoletes: kernel-modules, kernel-sparc
Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-%{kversion}-test7.tar.bz2
Source1: ftp://pcmcia-cs.sourceforge.net/pub/pcmcia-cs/pcmcia-cs-%{pcmciaver}.tar.gz
Source2: ftp://ftp.atnf.csiro.au/pub/people/rgooch/linux/daemons/devfsd-v%{devfsdver}.tar.gz
Source4: README.kernel-sources
Source5: ftp://ftp.ocs.com.au/pub/ksymoops/ksymoops-%{ksymoopsver}.tar.gz

Source10: pcmcia-cs-2.8.8-network.script
Source11: module-info
Source12: installkernel
Source13: rhkmvtag.c
Source14: kernel-2.4-BuildASM.sh
Source15: linux-rhconfig.h
Source16: linux-merge-config.awk
Source17: linux-merge-modules.awk

Source20: kernel-%{kversion}-i386.config
Source21: kernel-%{kversion}-i386-smp.config
Source22: kernel-%{kversion}-i386-BOOT.config
Source23: kernel-%{kversion}-alpha.config
Source24: kernel-%{kversion}-alpha-smp.config
Source25: kernel-%{kversion}-sparc.config
Source26: kernel-%{kversion}-sparc-smp.config
Source27: kernel-%{kversion}-sparc64.config
Source28: kernel-%{kversion}-sparc64-smp.config
Source29: kernel-%{kversion}-i686.config
Source30: kernel-%{kversion}-i686-smp.config
Source31: kernel-%{kversion}-alpha-BOOT.config
Source32: kernel-%{kversion}-sparc-BOOT.config
Source33: kernel-%{kversion}-sparc64-BOOT.config
Source34: kernel-%{kversion}-i586.config
Source35: kernel-%{kversion}-i586-smp.config
# since there are no modules yet (and no space issues)
# a -BOOT is rather pointless
Source36: kernel-%{kversion}-ia64.config
Source37: kernel-%{kversion}-ia64-smp.config
Source38: kernel-%{kversion}-i686-enterprise.config

# General bug fix patches first
# Large patches that change core kernel code next
# Driver specific patches last

Patch2: test8-pre1.bz2
Patch4: linux-2.4.0-cipe.patch
Patch6: linux-2.4.0-drm-alpha.patch
Patch7: linux-2.4.0-test7-pre4-emu10k1.patch
Patch8: linux-2.4.0-test6-apic.patch
Patch9: linux-2.4.0-test7-pre4-overflow.patch

Patch10: linux-2.4.0-ramdisk-size.patch
Patch11: kernel-2.4-string.patch
Patch12: linux-2.3.99-alpha.patch
Patch13: linux-2.3.99p3p6-sparc.patch
Patch14: linux-2.4.0-ia64-agpgart.patch
Patch18: linux-2.4.0-alpha.patch
Patch21: linux-2.2.16-useio.patch
Patch22: linux-2.4.0-nohighmemdebug.patch

# ia64-specific
Patch50: linux-2.4.0-test7-ia64-%{ia64version}.diff
Patch51: kernel-2.4.0-ia64-kmod.patch
Patch53: linux-2.4.0-ia64-flock64.patch

# loopback change
Patch60: linux-2.4.0-changeloop.patch

# TUX
Patch70: tux-2.4.0-test8-B5-nodebug

Patch100: megaraid-1e08.patch
Patch101: linux-2.4.0-test5-qla1280-1.patch
Patch102: linux-2.4.0-test5-qla1280-3.12.patch
Patch103: linux-2.4.0-qla2x00.patch
Patch104: linux-2.4.0-test5-compile.patch
Patch105: acenic-0.45.patch
Patch106: acenic-0.45-tux.patch
Patch107: linux-2.4.0-acenic-static.patch

Patch150: pcmcia-cs-%{pcmciaver}-script.patch
Patch151: pcmcia-cs-3.1.3-3com.patch
Patch152: pcmcia-cs-%{pcmciaver}-config.patch
Patch153: pcmcia-cs-%{pcmciaver}-kernel.patch
Patch154: linux-2.4-pcmcia-cp.patch

Patch200: ksymoops-2.3.4-install.patch

BuildRoot: /var/tmp/kernel-%{KVERREL}-root

%package -n kernel
Summary: The Linux kernel (the core of the Linux operating system)
Group: System Environment/Kernel
Provides: module-info
Autoreqprov: no
Requires: initscripts >= 5.03
Requires: devfsd, modutils >= 2.3.14

%package -n kernel-source
Summary: The source code for the Linux kernel.
Group: Development/System

%package -n kernel-headers
Summary: Header files for the Linux kernel.
Group: Development/System

%package -n kernel-doc
Summary: Various documentation bits found in the kernel source.
Group: Documentation

%package -n kernel-pcmcia-cs
Summary: The daemon and device drivers for using PCMCIA adapters.
Group: System Environment/Kernel
Obsoletes: pcmcia-cs

%package -n kernel-utils
Summary: Kernel related utilities.
Group: System Environment/Kernel

%package -n devfsd
Summary: Device filesystem management daemon
Group: System Environment/Kernel
Requires: kernel >= 2.3.46

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Red Hat Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%description -n kernel
The kernel package contains the Linux kernel (vmlinuz), the core of your
Red Hat Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%description -n kernel-source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned
to your particular hardware, if you are so inclined (and you know what
you're doing).

%description -n kernel-headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
kernel.

%description -n kernel-doc
This package contains documentation files form the kernel
source. Various bits of information about the Linux kernel and the
device drivers shipped with it are documented in these files. 

You'll want to install this package if you need a reference to the
options that can be passed to Linux kernel modules at load time.

%description -n kernel-pcmcia-cs
Many laptop machines (and some non-laptops) support PCMCIA cards for
expansion. Also known as "credit card adapters," PCMCIA cards are
small cards for everything from SCSI support to modems. PCMCIA cards
are hot swappable (i.e., they can be exchanged without rebooting the
system) and quite convenient to use. The kernel-pcmcia-cs package
contains a set of loadable kernel modules that implement an
applications program interface, a set of client drivers for specific
cards and a card manager daemon that can respond to card insertion and
removal events by loading and unloading drivers on demand.  The daemon
also supports hot swapping, so that the cards can be safely inserted
and ejected at any time.

Install the kernel-pcmcia-cs package if your system uses PCMCIA
cards.

%description -n kernel-utils
The kernel-utils package contains ksymoops, a utility that can be used
for decrypting the kernel's OOPS output.

%description -n devfsd
Daemon for managing the device filesystem (devfs)

%package -n kernel-smp
Summary: The Linux kernel compiled for SMP machines.
Group: System Environment/Kernel
Provides: kernel = %{version}
Requires: initscripts >= 5.03
Requires: devfsd, modutils >= 2.3.14

%description -n kernel-smp
This package includes a SMP version of the Linux kernel. It is
required only on machines with two or more CPUs, although it should
work fine on single-CPU boxes.

Install the kernel-smp package if your machine uses two or more CPUs.

%package -n kernel-enterprise
Summary: The Linux Kernel compiled with options for Enterprise server usage.
Group: System Environment/Kernel
Provides: kernel = %{version}
Requires: initscripts >= 5.03
Requires: devfsd, modutils >= 2.3.14

%description -n kernel-enterprise
This package includes a kernel that has appropriate configuration options
enabled for the typical large enterprise server.  This includes SMP support
for multiple processor machines, support for large memory configurations
and other appropriate items.

%package -n kernel-BOOT
Summary: The version of the Linux kernel used on installation boot disks.
Group: System Environment/Kernel
Provides: kernel = %{version}
Requires: initscripts >= 5.03
Requires: devfsd, modutils >= 2.3.14

%description -n kernel-BOOT
This package includes a trimmed down version of the Linux kernel.
This kernel is used on the installation boot disks only and should not
be used for an installed system, as many features in this kernel are
turned off because of the size constraints.

%package -n kernel-BOOTsmp
Summary: The Linux kernel used on installation boot disks for SMP machines.
Group: System Environment/Kernel
Provides: kernel = %{version}
Requires: initscripts >= 5.03
Requires: devfsd, modutils >= 2.3.14

%description -n kernel-BOOTsmp
This package includes a trimmed down version of the Linux kernel. This
kernel is used on the installation boot disks only and should not be used
for an installed system, as many features in this kernel are turned off
because of the size constraints. This kernel is used when booting SMP
machines that have trouble coming up to life with the uniprocessor kernel.

%prep
%setup -q -c -a 1 -a 2 -a 5
cd linux
mv ../devfsd* ../ksymoops* ../pcmcia* .
%patch2 -p1
%patch4 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1

%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch18 -p1
%patch21 -p1
%patch22 -p1

%ifarch ia64
%patch50 -p1
%patch51 -p0
%patch53 -p1
%endif

# LOOP_CHANGE_FD
%patch60 -p1

# TUX
# Not applied by default because it is insufficiently general.
# Uncomment to try TUX out.  You will need the tux rpm installed.
# TUX is only tested on x86 yet.  Note also that it conflicts
# with the acenic 0.45 patch, so you have to change which acenic
# patch is applied.
%patch70 -p1

# megaraid update
%patch100 -p1
# qla1280 pre-patch
%patch101 -p1
# qla1280
%patch102 -p1
# qla2100
%patch103 -p1 -b .qla2x00
# random compile fixes
%patch104 -p1
# acenic 0.45 -- the first is without TUX, the second is with TUX
# %patch105 -p1
%patch106 -p1
# fix for compiling acenic statically
%patch107 -p1

cd ksymoops-%{ksymoopsver}
# compile ksymoops statically
%patch200 -p1 -b .foo
cd ..

chmod +x arch/sparc*/kernel/check_asm.sh

mkdir configs
%ifarch i386 i586 i686
cp -fv $RPM_SOURCE_DIR/kernel-%{kversion}-i?86*.config configs
%else
%ifarch sparc sparc64
cp -fv $RPM_SOURCE_DIR/kernel-%{kversion}-sparc*.config configs
%else
cp -fv $RPM_SOURCE_DIR/kernel-%{kversion}-%{_target_cpu}*.config configs
%endif
%endif

# PCMCIA
%ifarch i386 i586 i686
cd pcmcia-cs-%{pcmciaver}
%patch150 -p1 -b .script
%patch151 -p2 -b .3com 
%patch152 -p2 -b .config
%patch153 -p1 -b .kernel
%patch154 -p2 -b .cpfix
cd ..
%else
rm -rf pcmcia-cs-%{pcmciaver}
%endif

# Bring in the Red Hat Kernel Module Version Tag program
cp $RPM_SOURCE_DIR/rhkmvtag.c .

# make sure the kernel has the sublevel we know it has...
perl -p -i -e "s/^SUBLEVEL.*/SUBLEVEL = %{sublevel}/" Makefile

# get rid of unwanted files
find . -name "*.orig" -exec rm -fv {} \;

chmod 755 arch/*/kernel/check_asm.sh

###
### build
###
%build

cd linux
# why glibc doesn't parse this instead of cpuinfo I don't know
NRPROC=`egrep -c "^cpu[0-9]+" /proc/stat || :` 
if [ $NRPROC -eq 0 ] ; then
	NRPROC=1
fi
#%ifarch alpha
## FIXME: SMP build seems to be broken on alpha for now
#NRPROC=1
## FIXME: End bug workaround
#%endif

DependKernel() {
    # is this a special kernel we want to build?
    if [ -n "$2" ] ; then
	Config=$1-$2
	KernelVer=%{version}-%{release}$2
	echo MAKE DEPEND FOR $2 $1 KERNEL...
    else
	Config=$1
	KernelVer=%{version}-%{release}
	echo MAKE DEPEND FOR up $1 KERNEL...
    fi
%ifarch i386 i586 i686
    cp $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config arch/i386/defconfig
%else
%ifarch sparc sparc64
    cp $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config arch/$1/defconfig
%else
    cp $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config arch/%{_target_cpu}/defconfig
%endif
%endif
    rm -f .config
    # make sure EXTRAVERSION says what we want it to say
    perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}$2/" Makefile
    make mrproper
    make oldconfig
    make dep
    make include/linux/version.h 
}

BuildKernel() {
    if [ -n "$1" ] ; then
	Config=%{_target_cpu}-$1
	KernelVer=%{version}-%{release}$1
	DependKernel %{_target_cpu} $1
	echo BUILDING A KERNEL FOR $1...
    else
	Config=%{_target_cpu}
	KernelVer=%{version}-%{release}
	DependKernel %{_target_cpu}
	echo BUILDING THE NORMAL KERNEL...
    fi

%ifarch i386 i586 i686
    make -j $NRPROC bzImage 
%else
    make -j $NRPROC boot 
%endif
    make -j $NRPROC modules
    # first make sure we are not loosing any .ver files to make mrporper's
    # removal of zero sized files.
    find include/linux/modules -size 0 | while read file ; do \
	echo > $file
    done
    # Start installing stuff
    mkdir -p $RPM_BUILD_ROOT/boot
    install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
    install -m 644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-$KernelVer
    mkdir -p $RPM_BUILD_ROOT/dev/shm
%ifarch ia64
    strip --strip-debug vmlinux
%endif
%ifarch i386 i586 i686
    cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
    cp vmlinux $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer
%else
%ifarch ia64
    mkdir -p $RPM_BUILD_ROOT/boot/efi
    install -m 755 vmlinux $RPM_BUILD_ROOT/boot/efi/vmlinux-$KernelVer
    ln -s efi/vmlinux-$KernelVer $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer
%else
    gzip -cfv vmlinux > vmlinuz
    install -m 644 vmlinuz $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
    install -m 755 vmlinux $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer
%endif
%endif
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer
    make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
%ifarch ia64
    strip --strip-debug `find $RPM_BUILD_ROOT/lib/modules/$KernelVer -type f` || :
%endif
    #Identify the modules directory with the Red Hat Kernel Module Version Tag
%ifnarch sparc64
    cc $RPM_OPT_FLAGS -o rhkmvtag rhkmvtag.c init/version.o
    ./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag
    rm -f rhkmvtag
%endif
}

BuildPCMCIA() {
    if [ -z "$1" ] ; then
	echo "BUILDING FOR NORMAL KERNEL..."
    else
	echo "BUILDING FOR $1..."
    fi
    make -C pcmcia-cs-%{pcmciaver} clean
    ( cd pcmcia-cs-%{pcmciaver}; ./Configure -n --kernel=$RPM_BUILD_DIR/%{name}-%{version}/linux \
	--target=$RPM_BUILD_ROOT --trust --cardbus --nopnp --srctree \
	--moddir=/lib/modules/%{KVERREL}$1 --sysv --rcdir=/etc/rc.d )
    perl -pi -e 's/\/usr\/man/'`echo %{_mandir} | sed 's_/_\\\\/_g'`/ pcmcia-cs-%{pcmciaver}/man/Makefile
    make -j $NRPROC MAKE="make -j $NRPROC" -C pcmcia-cs-%{pcmciaver} all
    mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/pcmcia
    make -C pcmcia-cs-%{pcmciaver} install
}

SaveHeaders() {
    echo "SAVING HEADERS for $1 $2"
    # deal with the kernel headers that are version specific
    mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/savedheaders/$2/$1
    install -m 644 include/linux/autoconf.h \
	$RPM_BUILD_ROOT/usr/src/linux-%{kversion}/savedheaders/$2/$1/autoconf.h
    install -m 644 include/linux/version.h \
	$RPM_BUILD_ROOT/usr/src/linux-%{kversion}/savedheaders/$2/$1/version.h
    mv include/linux/modules \
	$RPM_BUILD_ROOT/usr/src/linux-%{kversion}/savedheaders/$2/$1/
    echo $2 $1 ../../savedheaders/$2/$1/ >> $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/savedheaders/list
}

###
# DO it...
###

rm -rf $RPM_BUILD_ROOT

# enterprise kernel, only part of the i686 arch
%if %{buildenterprise}
%ifarch i686
BuildKernel enterprise
SaveHeaders enterprise %{_target_cpu}
%endif
%endif

%if %{buildsmp}
#SMP-ENABLED KERNEL
BuildKernel smp
%ifarch i386 i586 i686
BuildPCMCIA smp
%endif
SaveHeaders smp %{_target_cpu}
%endif

%if %{buildBOOT}
%ifnarch i586 i686 ia64
# BOOT kernel
BuildKernel BOOT
%ifarch i386
BuildPCMCIA BOOT
%endif
SaveHeaders BOOT %{_target_cpu}
%endif
%endif

%ifarch i386
DependKernel i586
SaveHeaders up i586
DependKernel i686
SaveHeaders up i686
%endif
%ifarch sparc
DependKernel sparc64
SaveHeaders up sparc64
%endif

%if %{buildsmp}
%ifarch i386
DependKernel i586 smp
SaveHeaders smp i586
DependKernel i686 smp
SaveHeaders smp i686
%endif
%ifarch sparc
DependKernel sparc64 smp
SaveHeaders smp sparc64
%endif
%endif

%if %{buildenterprise}
%ifarch i386
DependKernel i686 enterprise
SaveHeaders enterprise i686
%endif
%endif

# NORMAL KERNEL
BuildKernel
%ifarch i386 i586 i686
BuildPCMCIA
%endif
%ifarch i386 alpha sparc ia64
SaveHeaders up %{_target_cpu}
%endif

%ifnarch i586 i686 sparc64
make -C ksymoops-%{ksymoopsver}
# compile devfsd
cd devfsd
perl -pi -e "s,-O2,$RPM_OPT_FLAGS -D_GNU_SOURCE,g" GNUmakefile
make KERNEL_DIR=..
cd ..
%endif

###
### install
###

%install

cd linux
mkdir -p $RPM_BUILD_ROOT/{boot,sbin}
install -m 755 $RPM_SOURCE_DIR/installkernel $RPM_BUILD_ROOT/sbin/installkernel

%ifarch i586 i686 sparc64
# these don't need much
exit 0
%endif

mkdir -p $RPM_BUILD_ROOT/usr/include
ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion} 

%ifarch i386
mkdir -p $RPM_BUILD_ROOT/etc/pcmcia
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
# Install our own network up/down script
install -m755 $RPM_SOURCE_DIR/pcmcia-cs-2.8.8-network.script \
        $RPM_BUILD_ROOT/etc/pcmcia/network

# We need our own default /etc/sysconfig/pcmcia
cat > $RPM_BUILD_ROOT/etc/sysconfig/pcmcia <<EOF
PCMCIA=no
PCIC=
PCIC_OPTS=do_scan=0
CORE_OPTS=
CARDMGR_OPTS=-f
EOF

# Finally strip some binaries
for file in cardmgr cardctl probe scsi_info ftl_format ftl_check ; do
    strip -R .comment $RPM_BUILD_ROOT/sbin/$file
done
%endif

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
tar cf - . | tar xf - -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
ln -sf linux-%{kversion} $RPM_BUILD_ROOT/usr/src/linux
install -m 644 %{SOURCE4}  $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

%ifarch sparc
ln -s ../src/linux/include/asm-sparc $RPM_BUILD_ROOT/usr/include/asm-sparc
ln -s ../src/linux/include/asm-sparc64 $RPM_BUILD_ROOT/usr/include/asm-sparc64
mkdir $RPM_BUILD_ROOT/usr/include/asm
cp -a $RPM_SOURCE_DIR/kernel-2.4-BuildASM.sh $RPM_BUILD_ROOT/usr/src/linux/include/asm-sparc/BuildASM
$RPM_BUILD_ROOT/usr/include/asm-sparc/BuildASM $RPM_BUILD_ROOT/usr/include
%else
ln -sf ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
%endif

#clean up the destination
%ifarch i386
make clean -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/pcmcia-cs-%{pcmciaver}
%endif

make mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make oldconfig -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make symlinks -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make include/linux/version.h -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

#this generates modversions info which we want to include and we may as
#well include the depends stuff as well, after we fix the paths
make depend -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
find $RPM_BUILD_ROOT/usr/src/linux-%{kversion} -name ".*depend" | \
while read file ; do
    mv $file $file.old
    sed -e "s|[^ ]*\(/usr/src/linux\)|\1|g" < $file.old > $file
    rm -f $file.old
done

# Try to put some smarter autoconf.h and version.h files in place
pushd $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux ; {
rm -rf modules modversions.h autoconf.h version.h
cat > modversions.h <<EOF
#ifndef _LINUX_MODVERSIONS_H
#define _LINUX_MODVERSIONS_H
#include <linux/rhconfig.h>
#include <linux/modsetver.h>
EOF
echo '#include <linux/rhconfig.h>' > autoconf.h
list=`find ../../savedheaders/*/*/modules/*.ver -exec basename '{}' \; | sort -u`
mkdir modules
for l in $list; do
    sed 's,$,modules/'$l, ../../savedheaders/list | awk -f %{SOURCE17} > modules/$l
    touch -r modules/$l modules/`basename $l .ver`.stamp
    echo '#include <linux/modules/'$l'>' >> modversions.h
done
echo '#endif' >> modversions.h
sed 's,$,autoconf.h,' ../../savedheaders/list | awk -f %{SOURCE16} >> autoconf.h
install -m 644 %{SOURCE15} rhconfig.h
echo "#include <linux/rhconfig.h>" >> version.h
keyword=if
for i in smp BOOT BOOTsmp enterprise up; do
    if [ -f ../../savedheaders/%{_target_cpu}/$i/version.h ]; then
	if [ "$i" = up ]; then
	    echo "#else" >> version.h
	else
	    echo "#$keyword defined(__module__$i)" >> version.h
	    keyword=elif
	fi
	grep UTS_RELEASE ../../savedheaders/%{_target_cpu}/$i/version.h >> version.h
    fi
done
echo "#endif" >> version.h
grep -v UTS_RELEASE ../../savedheaders/%{_target_cpu}/up/version.h >> version.h
rm -rf ../../savedheaders
} ; popd
> $RPM_BUILD_ROOT/boot/kernel.h-%{kversion}

# other tools
strip -R .comment ksymoops-%{ksymoopsver}/ksymoops devfsd/devfsd
make install -C ksymoops-%{ksymoopsver} INSTALL_PREFIX=$RPM_BUILD_ROOT%{_prefix} INSTALL_MANDIR=$RPM_BUILD_ROOT%{_mandir}/man8
mkdir -p $RPM_BUILD_ROOT/sbin $RPM_BUILD_ROOT%{_mandir}/man8 $RPM_BUILD_ROOT/etc
install -m 755 -s devfsd/devfsd $RPM_BUILD_ROOT/sbin/devfsd
cp -p devfsd/devfsd.8 $RPM_BUILD_ROOT%{_mandir}/man8
cp -p devfsd/devfsd.conf $RPM_BUILD_ROOT/etc/devfsd.conf

make clean -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/ksymoops-%{ksymoopsver}
make clean -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/devfsd

rm -f $RPM_BUILD_ROOT/usr/include/linux
mkdir -p $RPM_BUILD_ROOT/usr/include/linux
cp -a $RPM_BUILD_ROOT/usr/src/linux/include/linux/* $RPM_BUILD_ROOT/usr/include/linux/
rm -rf $RPM_BUILD_ROOT/usr/include/linux/modules
echo "#error Modules should never use kernel-headers system headers," > $RPM_BUILD_ROOT/usr/include/linux/modversions.h
echo "#error but headers from an appropriate kernel-source" >> $RPM_BUILD_ROOT/usr/include/linux/modversions.h
%ifarch sparc
rm -f $RPM_BUILD_ROOT/usr/include/asm-sparc
mkdir -p $RPM_BUILD_ROOT/usr/include/asm-sparc
cp -a $RPM_BUILD_ROOT/usr/src/linux/include/asm-sparc/* $RPM_BUILD_ROOT/usr/include/asm-sparc/
rm -f $RPM_BUILD_ROOT/usr/include/asm-sparc64
mkdir -p $RPM_BUILD_ROOT/usr/include/asm-sparc64
cp -a $RPM_BUILD_ROOT/usr/src/linux/include/asm-sparc64/* $RPM_BUILD_ROOT/usr/include/asm-sparc64/
%else
rm -f $RPM_BUILD_ROOT/usr/include/asm
mkdir -p $RPM_BUILD_ROOT/usr/include/asm
cp -a $RPM_BUILD_ROOT/usr/src/linux/include/asm/* $RPM_BUILD_ROOT/usr/include/asm/
%endif

for i in $RPM_BUILD_ROOT/lib/modules/*; do
  rm -f $i/build $i/modules.dep $i/modules.pcimap
  ln -sf /usr/src/linux-%{kversion} $i/build
done

###
### clean
###

%clean
#rm -rf $RPM_BUILD_ROOT

###
### scripts
###

# do this for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.
%pre -n kernel
/sbin/modprobe loop 2> /dev/null > /dev/null
exit 0

%post -n kernel
cd /boot
%ifnarch ia64
ln -sf vmlinuz-%{KVERREL} vmlinuz
%endif
ln -sf System.map-%{KVERREL} System.map
ln -sf module-info-%{KVERREL} module-info
depmod -a -i -m /boot/System.map-%{KVERREL} %{KVERREL}

%post -n kernel-smp
depmod -a -i -m /boot/System.map-%{KVERREL}smp %{KVERREL}smp

%post -n kernel-enterprise
depmod -a -i -m /boot/System.map-%{KVERREL}enterprise %{KVERREL}enterprise

%ifnarch ia64
%post -n kernel-BOOT
depmod -a -i -m /boot/System.map-%{KVERREL}BOOT %{KVERREL}BOOT
%endif

# Allow clean removal of modules directory
%preun -n kernel
rm -f /lib/modules/%{KVERREL}/modules.dep
rm -f /lib/modules/%{KVERREL}/modules.pcimap

%preun -n kernel-smp
rm -f /lib/modules/%{KVERREL}smp/modules.dep
rm -f /lib/modules/%{KVERREL}smp/modules.pcimap

%preun -n kernel-enterprise
rm -f /lib/modules/%{KVERREL}enterprise/modules.dep
rm -f /lib/modules/%{KVERREL}enterprise/modules.pcimap

%preun -n kernel-BOOT
rm -f /lib/modules/%{KVERREL}BOOT/modules.dep
rm -f /lib/modules/%{KVERREL}BOOT/modules.pcimap

%ifarch i386 i586 i686
if [ -x /sbin/lilo -a -f /etc/lilo.conf ]; then
	/sbin/lilo > /dev/null 2>&1
	exit 0
fi
%endif

%pre -n kernel-headers
[ -L /usr/include/linux ] && rm -f /usr/include/linux
[ -L /usr/include/asm ] && rm -f /usr/include/asm
%ifarch sparc
[ -L /usr/include/asm-sparc ] && rm -f /usr/include/asm-sparc
[ -L /usr/include/asm-sparc64 ] && rm -f /usr/include/asm-sparc64
%endif
exit 0

%post -n kernel-headers
cd /boot
rm -f kernel.h
ln -snf kernel.h-%{kversion} kernel.h
exit 0

# Old kernel-headers packages owned include symlinks; new
# ones just make them so that we can have multiple kernel-headers
# packages installed.
%triggerpostun -n kernel-headers -- kernel-headers < 2.2.16
cd /boot
rm -f kernel.h
ln -snf kernel.h-%{kversion} kernel.h
exit 0

%triggerpostun -n kernel-source -- kernel-headers < 2.2.16
cd /usr/src
rm -f %{kslnk}
ln -snf linux-%{kversion} %{kslnk}
exit 0

%post -n kernel-source
cd /usr/src
rm -f %{kslnk}
ln -snf linux-%{kversion} %{kslnk}

%postun -n kernel-headers
if [ $1 = 0 ]; then
    if [ -L /boot/kernel.h -a `ls -l /boot/kernel.h 2>/dev/null| awk '{ print $11 }'` = "kernel.h-%{kversion}" ]; then
	rm -f /boot/kernel.h
    fi
fi
exit 0

%postun -n kernel-source
if [ -L /usr/src/%{kslnk} ]; then 
    if [ -L /usr/src/%{kslnk} -a `ls -l /usr/src/%{kslnk} 2>/dev/null| awk '{ print $11 }'` = "linux-%{kversion}" ]; then
	[ $1 = 0 ] && rm -f /usr/src/%{kslnk}
    fi
fi
exit 0

%ifarch i386
%post -n kernel-pcmcia-cs
/sbin/chkconfig --add pcmcia

%preun -n kernel-pcmcia-cs
if [ $1 = 0 ]; then
    /sbin/chkconfig --del pcmcia
fi
exit 0

%triggerpostun -- kernel-pcmcia-cs < 2.2.5
if [ -f /etc/rc.d/init.d/pcmcia ] ; then
    /sbin/chkconfig --add pcmcia
fi

%endif

###
### file lists
###

%files -n kernel
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}
%ifarch ia64
/boot/efi/vmlinux-%{KVERREL}
%endif
%ifnarch ia64
/boot/vmlinuz-%{KVERREL}
%endif
/boot/module-info-%{KVERREL}
/boot/System.map-%{KVERREL}
%config /sbin/installkernel
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}

%if %{buildsmp}
%files -n kernel-smp
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}smp
%ifarch ia64
/boot/efi/vmlinux-%{KVERREL}smp
%endif
%ifnarch ia64
/boot/vmlinuz-%{KVERREL}smp
%endif
/boot/module-info-%{KVERREL}smp
/boot/System.map-%{KVERREL}smp
%config /sbin/installkernel
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}smp
%endif

%if %{buildenterprise}
%ifarch i686
%files -n kernel-enterprise
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}enterprise
/boot/vmlinuz-%{KVERREL}enterprise
/boot/module-info-%{KVERREL}enterprise
/boot/System.map-%{KVERREL}enterprise
%config /sbin/installkernel
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}enterprise
%endif
%endif

%if %{buildBOOT}
%ifnarch i586 i686 ia64
%files -n kernel-BOOT
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}BOOT
/boot/vmlinuz-%{KVERREL}BOOT
/boot/System.map-%{KVERREL}BOOT
%config /sbin/installkernel
%dir /lib/modules
%dir /dev/shm
/lib/modules/%{KVERREL}BOOT
%endif
%endif

%ifnarch i586 i686 sparc64
# START BASE ARCHES ONLY
%ifarch i386 alpha sparc ia64

%files -n kernel-source
%defattr(-,root,root)
%dir /usr/src/linux-%{kversion}
/usr/src/linux-%{kversion}/COPYING
/usr/src/linux-%{kversion}/CREDITS
/usr/src/linux-%{kversion}/Documentation
/usr/src/linux-%{kversion}/MAINTAINERS
/usr/src/linux-%{kversion}/Makefile
/usr/src/linux-%{kversion}/README
/usr/src/linux-%{kversion}/REPORTING-BUGS
/usr/src/linux-%{kversion}/Rules.make
%ifarch i386 i586 i686
/usr/src/linux-%{kversion}/arch/i386
%else
/usr/src/linux-%{kversion}/arch/%{_target_cpu}
%endif
%ifarch sparc
/usr/src/linux-%{kversion}/arch/sparc64
%endif
/usr/src/linux-%{kversion}/drivers
/usr/src/linux-%{kversion}/fs
/usr/src/linux-%{kversion}/init
/usr/src/linux-%{kversion}/ipc
/usr/src/linux-%{kversion}/kernel
/usr/src/linux-%{kversion}/lib
/usr/src/linux-%{kversion}/mm
/usr/src/linux-%{kversion}/net
/usr/src/linux-%{kversion}/scripts
/usr/src/linux-%{kversion}/devfsd
/usr/src/linux-%{kversion}/ksymoops-%{ksymoopsver}
%ifarch i386
/usr/src/linux-%{kversion}/pcmcia-cs-%{pcmciaver}
%endif
/usr/src/linux-%{kversion}/configs
%ifarch sparc
/usr/src/linux-%{kversion}/include/asm-sparc
/usr/src/linux-%{kversion}/include/asm-sparc64
%else
%ifarch i386 i586 i686
/usr/src/linux-%{kversion}/include/asm-i386
%else
/usr/src/linux-%{kversion}/include/asm-%{_target_cpu}
%endif
%endif
/usr/src/linux-%{kversion}/include/asm
/usr/src/linux-%{kversion}/include/asm-generic
/usr/src/linux-%{kversion}/include/linux
/usr/src/linux-%{kversion}/include/net
/usr/src/linux-%{kversion}/include/scsi
/usr/src/linux-%{kversion}/include/video
%ifarch alpha sparc
/usr/src/linux-%{kversion}/include/math-emu
%endif  

%files -n kernel-utils
%defattr(-,root,root)
%doc linux/scripts/ksymoops/README
/usr/bin/ksymoops
%{_mandir}/man8/ksymoops.8*

%files -n devfsd
%defattr(-,root,root)
/sbin/devfsd
%{_mandir}/man8/devfsd.8*
%config /etc/devfsd.conf

%files -n kernel-headers
%defattr(-,root,root)
/usr/include/linux
/usr/include/asm
%ifarch sparc
/usr/include/asm-sparc
/usr/include/asm-sparc64
%endif
/boot/kernel.h-%{kversion}

%files -n kernel-doc
%defattr(-,root,root)
%doc linux/Documentation/*

%endif
# END BASE ARCHES ONLY
%endif

%ifarch i386
%files -n kernel-pcmcia-cs
%defattr(-,root,root)
%doc linux/pcmcia-cs-%{pcmciaver}/doc/PCMCIA-HOWTO 
%doc linux/pcmcia-cs-%{pcmciaver}/doc/PCMCIA-PROG
%doc linux/pcmcia-cs-%{pcmciaver}/SUPPORTED.CARDS 
%doc linux/pcmcia-cs-%{pcmciaver}/CHANGES 
%doc linux/pcmcia-cs-%{pcmciaver}/COPYING 
%doc linux/pcmcia-cs-%{pcmciaver}/README
%attr(755,root,root) /sbin/cardctl
/sbin/cardmgr
/sbin/ftl_check
/sbin/ftl_format
/sbin/ifport
/sbin/ifuser
/sbin/pcinitrd
/sbin/probe
/sbin/scsi_info
%{_mandir}/man[45]/*
%{_mandir}/man8/[a-c]*
%{_mandir}/man8/dump_cis.8*
%{_mandir}/man8/[e-j]*
%{_mandir}/man8/[l-z]*
%config /etc/rc.d/init.d/pcmcia
# The installer will put the right information in it. We should
# install the new one with extension .rpmnew since it is not
# correct for notebook. H.J.
%config(noreplace) /etc/sysconfig/pcmcia
%dir /etc/pcmcia
/etc/pcmcia/config
/etc/pcmcia/ftl
/etc/pcmcia/ide
/etc/pcmcia/memory
/etc/pcmcia/network
/etc/pcmcia/scsi
/etc/pcmcia/serial
/etc/pcmcia/shared
/etc/pcmcia/cis
%config /etc/pcmcia/config.opts
%config /etc/pcmcia/ftl.opts
%config /etc/pcmcia/ide.opts
%config /etc/pcmcia/memory.opts
%config /etc/pcmcia/scsi.opts
%config /etc/pcmcia/serial.opts
%endif

%changelog
* Thu Aug 31 2000 Michael K. Johnson <johnsonm@redhat.com>
- More work on TUX: new version, better integration, still incomplete
- updated to 2.4.0-test8-pre1
- temporarily disabled matrox maven driver because of ICE

* Thu Aug 24 2000 Michael K. Johnson <johnsonm@redhat.com>
- Added TUX (but currently commented out because of insufficient generality)
- Config files mention tux so that the SRPM will still build if you add
  the patch.  However, they will not build TUX in without changes.

* Wed Aug 16 2000 Michael K. Johnson <johnsonm@redhat.com>
- dropped pcmcia-cs copy -f fix in from 2.2

* Tue Aug 15 2000 Bill Nottingham <notting@redhat.com>
- update ia64 stuff

* Tue Aug 15 2000 Jakub Jelinek <jakub@redhat.com>
- update to test7-pre4
- fix emu10k1 build on alpha
- .config updates

* Mon Aug 14 2000 Jakub Jelinek <jakub@redhat.com>
- fix linux-merge-config.awk
- remove /usr/include/{linux,asm*} in kernel-headers %pre

* Thu Aug 10 2000 Bill Nottingham <notting@redhat.com>
- update to test6-final (vger patch is merged)

* Wed Aug  9 2000 Jakub Jelinek <jakub@redhat.com>
- update to test6/pre9
- apply vger patches
- make it build on sparc32

* Tue Aug  8 2000 Bill Nottingham <notting@redhat.com>
- make it build on ia64

* Tue Aug  8 2000 Jakub Jelinek <jakub@redhat.com>
- /usr/include/{linux,asm} are directories
- fix header merging
- update to test6/pre8

* Wed Aug  2 2000 Bill Nottingham <notting@redhat.com>
- add ia32 signal patch for ia64

* Tue Aug  1 2000 Bill Nottingham <notting@redhat.com>
- update to pre5/ia64-728 (argh)
- update qla2x00 scsi driver to 4.0 (from Qlogic)

* Wed Jul 26 2000 Bill Nottingham <notting@redhat.com>
- clean up the %posts some

* Wed Jul 26 2000 Jakub Jelinek <jakub@redhat.com>
- Rename kernel24 subpackages back
- parport fix from Tim Waugh
- make it build on Alpha (hopefully)

* Wed Jul 26 2000 Jakub Jelinek <jakub@redhat.com>
- kill some of the ugly hacks, replace them with other ugly
  hacks so that the package can be built as the main distribution
  kernel or an experimental one.
- fix the export memcpy/memset patch
- add enterprise kernel (64GB kernel) on i686

* Tue Jul 25 2000 Bill Nottingham <notting@redhat.com>
- ugly hacks to get just the headers out

* Tue Jul 25 2000 Jakub Jelinek <jakub@redhat.com>
- kill several unresolved symbols from modules

* Fri Jul 21 2000 Bill Nottingham <notting@redhat.com>
- more tweaks

* Thu Jul 20 2000 Jakub Jelinek <jakub@redhat.com>
- some more tweaks

* Tue Jul 18 2000 Jakub Jelinek <jakub@redhat.com>
- CIPE
- a couple of patchlets
- FHS tweaks

* Wed Jun 21 2000 Bill Nottingham <notting@redhat.com>
- update acenic, megaraid, qla1280 drivers
- minor kernel header tweak for userland

* Sat Jun 17 2000 Bill Nottingham <notting@redhat.com>
- bump up ramdisk size on ia64 & alpha
- compile more stuff into the kernel until modules work better

* Fri Jun 16 2000 Bill Nottingham <notting@redhat.com>
- add ia32 signal handling patch for ia64

* Thu Jun 15 2000 Jakub Jelinek <jakub@redhat.com>
- reenable changeloop patch

* Wed Jun 14 2000 Bill Nottingham <notting@redhat.com>
- merge in loopback fixes from -ac series

* Tue Jun 13 2000 Bill Nottingham <notting@redhat.com>
- ia64 updates (0609 patch)
- module config/versioning updates

* Mon Jun  5 2000 Bill Nottingham <notting@redhat.com>
- merge in the ia64 stuff
- move to /dev/shm

* Sat Jun  3 2000 Jakub Jelinek <jakub@redhat.com>
- fix rhconfig.h (from Bero)

* Mon May 29 2000 Jakub Jelinek <jakub@redhat.com>
- 2.4.0-test1
- changeloop patch
- fix BuildASM
- fix compilation with gcc 2.96
- fix devfsd compilation

* Sat May  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- pre7-6
- devfsd 1.3.8
- add even more confusion to the versioning hell ;)
  (so we can deal with pre-pre versions)

* Fri Apr 28 2000 Bill Nottingham <notting@redhat.com>
- update for ia64
- pre6-final
- don't apply abi patch until it stops imploding on boot

* Mon Apr 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.3.99pre6-pre3
- update ksymoops to 2.3.4
- update pcmcia to 3.1.14
- devfsd 1.3.4, devfs 162
- link ksymoops statically to get rid of the dependency on a particular
  version of binutils
- adapt abi patch to new kernel interfaces
- minor fixes to spec file

* Wed Mar 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.3.99pre3-7
- remove some fixes (they're now in the base version)

* Tue Mar 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add /var/shm dir
- require initscripts >= 5.03 so we mount /var/shm
- 2.3.99pre3-3
- fix compilation of some buggy drivers
- fix build on sparc64

* Thu Mar 16 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.3.99pre2-3
- replace iBCS with abi, remove patches
- port abi to 2.3.99pre2-3
- fix packaging bug (ksymoops.8* was included in kernel-utils AND
  kernel-pcmcia-cs)
- add devfsd
- fix compilation on alpha (fix various kernel bugs and work
  around a compiler bug)

* Tue Mar 07 2000 Cristian Gafton <gafton@redhat.com>
- fix stupidity in the agphjlfixes. make xconfig work again
- security patches from Alan (4 of them) (patch75-78)
- acenic sparc patch from davem (patch79)

* Tue Mar 07 2000 Doug Ledford <dledford@redhat.com>
- Added third sparc cpu bug fix patch from davem

* Mon Mar 06 2000 Cristian Gafton <gafton@redhat.com>
- fix symbol versioning on the alpha so we don't get any more unresolved
  dependencies

* Mon Mar 06 2000 Doug Ledford <dledford@redhat.com>
- Added three new sparc patches from davem
- Updated boot kernel config files to include SysV IPC support so the X
  server used during graphical install will be able to use shared mem

* Sun Mar 05 2000 Doug Ledford <dledford@redhat.com>
- Put the megaraid v107 patch back in now that it has been cleared
  from suspicion in the megaraid lockup problem.

* Sat Mar 04 2000 Doug Ledford <dledford@redhat.com>
- Back the megaraid driver back down to version 1.05 and remove the extra
  megaraid patch that was added in the last RPM build

* Sat Mar 04 2000 Doug Ledford <dledford@redhat.com>
- Fix the pcmcia build function to answer the questions in the make config
  process correctly
- Upped the number of extra scsi disk structs to allow for adding drives at
  run time
- Fixed the sparc config files to enable RAID partition autodetection
- Added a delay to the megaraid detection routine to keep it from locking
  up the SCSI bus when you try to beat on it immediately after startup

* Fri Mar 03 2000 Doug Ledford <dledford@redhat.com>
- Updated the sparc-mmap patch to correct a slight oversight in the original
- added the nautilus-srm patch for alpha machines

* Thu Mar 02 2000 Doug Ledford <dledford@redhat.com>
- Updated the alpha configs to include network socket filter so dhcp works
- added the aic7xxx-5.1.28 patch
- added the sparc Ultrasparc II CPU bug patch from davem

* Mon Feb 28 2000 Doug Ledford <dledford@redhat.com>
- Added the ibcs locking patch
- Added the sparc raid patch
- Added the sparc mmap patch
- Added the sparc lockd patch
- Kept the actual kernel version (2.2.14-5.0) frozen instead of incrementing
  it.

* Wed Feb 23 2000 Cristian Gafton <gafton@redhat.com>
- insert doug's changelog: added the ipvs-template patch

* Fri Feb 18 2000 Doug Ledford <dledford@redhat.com>
- Replace the IDE no printk patch with the more correct ide-cd-shutup patch
  from Jens Axboe
- Update the PSI drivers
- Added Jakub's patch to keep the sparc kernel from complaining about not
  knowing what the LFS syscalls are
- Added a patch to make the sk98 driver friendly to non-32 bit machines
- Updated config files to turn on the sk98 driver, and the PCI2000 and PCI2200
  drivers
- Added aic7xxx-5.1.27 patch

* Wed Feb 16 2000 Zach Brown <zab@redhat.com>
- bring acenic up to Jes' recommended 0.41
- enable acenic on alpha and sparc64
- disable vfs disk change printk

* Wed Feb 16 2000 Doug Ledford <dledford@redhat.com>
- added patch for probing all luns on megaraid logical devices
- added patch to increase number of loop devices
- modified spec file to make /etc/sysconfig/pcmcia a %config(noreplace) file
- added aic7xxx-5.1.26 driver

* Fri Feb 11 2000 Zach Brown <zab@redhat.com>
- added newagp module with bugfixes 
- added sblive emu10k1 driver
- added pre7 eepro100 fixes

* Thu Feb 10 2000 Doug Ledford <dledford@redhat.com>
- Added in all of Alan and Dave's various kernel fixes (patch numbers 42
  through 64 are from the 2.2.15-pre kernel series)

* Tue Feb 08 2000 Doug Ledford <dledford@redhat.com>
- Backed kernel back down to 2.2.14 official instead of 2.2.15-pre5
- Added back in the MegaRAID patch, timersync patch, and various aic7xxx
  patches that used to be part of 2.2.15-pre5
- Turned off the nfsattack2 patch because A) it didn't apply cleanly any more
  and B) Alan thought that the straight 2.2.14 kernel nfsd would be the
  best version of NFS to use
- Undid the bigmem patch changes so it would apply to 2.2.14 again

* Tue Feb 08 2000 Cristian Gafton <gafton@redhat.com>
- make atyfb and pm2 available as modules instead of compiling them in
  (patch from jakub + config files update)

* Sat Feb  5 2000 Matt Wilson <msw@redhat.com>
- disable strip build root policy

* Fri Feb 04 2000 Cristian Gafton <gafton@redhat.com>
- updated the nfsd patch

* Fri Feb  4 2000 Matt Wilson <msw@redhat.com>
- added patch from Jakub to make new nfs build on sparc

* Fri Feb 04 2000 Zach Brown <zab@redhat.com>
- Added HJL's 2.2.14 NFS patches
- Fixed typo in creative joystick
- ksymoops now doesn't require libbfd (care of hjl)
- Andrea's kiobuf buffer overflow fix
- Silence mostly harmless printk in sun disk label code
- Turned off solaris emulation 
- add AGPGART for x86

* Sat Jan 29 2000 Doug Ledford <dledford@redhat.com>
- Updated to 2.2.15-pre5
- Removed duplicate patches that are now in 2.2.15-pre5 (megaraid,
  aic7xxx 1 and 2, timersync)
- Updated config files to turn on all fb devs on x86
- Enabled disk label support on x86
- Added the pre5 sparc config patch
- Added the Alpha arch. ramdisk size patch
- Added the Compaq Smart2 Array driver update patch
- Fixed the non-lfs version of the bigmem patch to apply to pre5.  The
  lfs version will need fixed similarly, but hasn't been done yet.

* Sun Jan 16 2000 Doug Ledford <dledford@redhat.com>
- Replaced the sigio patch with one that should compile on Sparc
  platforms (from Jakub Jelinek <jakub@redhat.com>)
- Added the SIGFPE patch to correct the problem where linux does not
  correctly set the siginfo struct values during a SIGFPE signal with
  unmasked FPU exceptions

* Sat Jan 15 2000 Doug Ledford <dledford@redhat.com>
- Added the aic7xxx-5.1.23 patch
- Added the sigio patch from Zach Brown <zab@redhat.com>
- Added the timersync patch from Ingo Molnar <mingo@redhat.com> to fix
  some SMP time mismatch problems on 8way machines
- Added the removal of the module.info file to the %preun scripts
- Updated to v1.07 of the AMI MegaRAID driver

* Fri Jan 07 2000 Doug Ledford <dledford@redhat.com>
- Modified DAC960 driver to use 4 bits of the minor for partitions so
  that it can support up to 16 partitions on a single logical
  device (default is 3 bits and 8 partitions)
- Enabled SMBFS support (as modules) on the Alpha platform
- Excluded irq 12 from the available irqs (needed to help on systems
  with PS/2 mice, should probably go away after USB based keyboard
  and mouse systems become the norm)

* Wed Jan 05 2000 Doug Ledford <dledford@redhat.com>
- Replaced single LFS patch with split LFS headers and LFS functions
  patch supplied by Jakub.
- Enabled LFS headers patch all the time so glibc can be built
  against this kernel and have knowledge about 64bit file ops

* Tue Jan 04 2000 Doug Ledford <dledford@redhat.com>
- Updated to Linus Official Penguin Pee 2.2.14 kernel
- Re-Upgraded bigmem patch to the 2.2.13-7 version (latest)
  with one fix to make Samba work again
- Turned off LFS patch for regular tree build
- Now have to versions of the bigmem patch, one for use with LFS
  and one for use without LFS

* Mon Jan 03 2000 Doug Ledford <dledford@redhat.com>
- Updated to pre-patch-2.2.14-18
- Downgraded bigmem patches to the previous version
- Added an IO-APIC patch to fix machines that don't give
  multiple IO-APICs in the same computer different APIC
  IDs

* Sun Dec 26 1999 Doug Ledford <dledford@redhat.com>
- Updated to pre-patch-2.2.14-16
- Updated to ipvs-0.9.7-2.2.13.patch

* Mon Dec 20 1999 Doug Ledford <dledford@redhat.com>
- Updated LFS patch to fix nfsd compile problems
- Rearrange ipvs patch to match HA groups kernel RPMS

* Sat Dec 18 1999 Doug Ledford <dledford@redhat.com>
- 2.2.14pre15
- LFS patch (64bit file I/O)
- Updated to 2.2.13-7 version of BIGMEM patch

* Thu Dec 16 1999 Doug Ledford <dledford@redhat.com>
- Added aic7xxx patch
- 2.2.14pre14

* Thu Dec  9 1999 Bill Nottingham <notting@redhat.com>
- fix broken symbols in multisound driver on alpha
- 2.2.14pre12

* Mon Dec 06 1999 Doug Ledford <dledford@redhat.com>
- Modified the PIII patch break over point for better performance
- Modified packaging so that the configs are part of the header
  RPM instead of the source RPM
- Updated config files (set all configs to 1GB kernel)

* Sun Dec 05 1999 Doug Ledford <dledford@redhat.com>
- Put in a new PIII patch and re-enabled the PIII kernels
- Updated to 2.2.14pre11

* Tue Nov 30 1999 Matt Wilson <msw@redhat.com>
- removed some things from alpha BOOT kernel

* Sat Nov 27 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.14pre9

* Tue Nov 23 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.14pre8
- compile raid in on alpha (no initrd)

* Fri Nov 19 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.14pre7
- oops, turn off vga16fb
- add alpha math patch (jakub)

* Tue Nov 16 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.14pre6
- new ipvs patch
- new PIII patch

* Fri Nov 12 1999 Matt Wilson <msw@redhat.com>
- added patch from davem to fix the kernel socket filter
- modified sparc config files to match other architectures
- added patch from Jalub to properly draw the bootup logo on the 3dlabs card

* Wed Nov 10 1999 Bill Nottingham <notting@redhat.com>
- new permedia2 patch (jakub)
- turn on stop-a when we print out 'hit l1-a to go to prom' (jakub)

* Mon Nov  8 1999 Matt Wilson <msw@redhat.com>
- added patch from davem for new hardware
- permedia2 patch (jakub)

* Fri Nov  4 1999 Bill Nottingham <notting@redhat.com>
- patch for multiple Creator/Elite framebuffers (davem)
- ship include/math-emu on sparc (jakub)
- turn on video & joystick modules on Alpha

* Wed Nov  3 1999 Bill Nottingham <notting@redhat.com>
- dbri patch (davem)
- sparc initrd patch (jakub)

* Tue Nov  2 1999 Bill Nottingham <notting@redhat.com>
- new sparc patch (DaveM)

* Fri Oct 29 1999 Bill Nottingham <notting@redhat.com>
- patch for raid resync
- patch for alpha TGA from Jay
- syncookie patch from Alan

* Thu Oct 28 1999 Matt Wilson <msw@redhat.com>
- added latest DaveM sparc patch

* Mon Oct 25 1999 Cristian Gafton <gafton@redhat.com>
- disable PIII patch (Doug, here we go again...)
- last sparc kernel patch. davem swears by it.

* Tue Oct 19 1999 Cristian Gafton <gafton@redhat.com>
- more sparc fixes (update kernel patch from DaveM)...
- change the sparc64 config files to use SYM53C8XX instead of NCR53C8XX

* Tue Oct 12 1999 Cristian Gafton <gafton@redhat.com>
- update the Sparc patch again
- add patch for the sigoops problem
- fix undefined symbols for alpha for nm256.o and msnd_classic.o
- don't boot an alpha BOOTsmp kernel anymore

* Mon Oct 11 1999 Doug Ledford <dledford@redhat.com>
- New patch for Symbios SCSI controllers in Compaq machines
- New patch for peer pci busses (supports the RCC HE and LE chipsets)
- Updated Xircom patch
- Added 3Com official driver patch

* Mon Oct 11 1999 Cristian Gafton <gafton@redhat.com>
- sparc patch from DaveM

* Fri Oct 08 1999 Cristian Gafton <gafton@redhat.com>
- leave the bigmem patches enabled only on the Intel
- update sparc patch from davem

* Thu Oct 07 1999 Doug Ledford <dledford@redhat.com>
- Put in a new peerbus patch to try and support the new RCC chipset
- Add a modified version of the pcnet32 patch for HP
- Patched the 3Com cardbus driver to support version C 575 cards
- Updated Xircom patch for the tulip_cb.c driver

* Mon Oct 04 1999 Doug Ledford <dledford@redhat.com>
- changes to the tulip_cb.c driver for Xircom cards
- added bigmem patches from Stephen Tweedie (adapted from
  patches originally authored by Andrea Arcangeli from SuSE
  and Gerhard Wichert of Siemens AG)
- added various bigmem support patches
- added new version of linux-2.2.12-sparc-diff.gz from Dave Miller
- added new linux-2.2.12-alpha-diffs.patch file from Jay Estabrook

* Thu Sep 30 1999 Doug Ledford <dledford@redhat.com>
- Re-added the PIII patches
- Started working on the Xircom cardbus driver (tulip_cb.o)

* Tue Sep 28 1999 Cristian Gafton <gafton@redhat.com>
- update sparc patches from davem
- enable CONFIG_SPARCAUDIO_AMD7930 and CONFIG_SPARCAUDIO_DBRI on sparc as
  modules

* Mon Sep 27 1999 Cristian Gafton <gafton@redhat.com>
- patch to fix xtime SMP lockup problem from DaveM
- patch to fix the IDE poll lockups
- make building modules for SMP work okay

* Sun Sep 26 1999 Cristian Gafton <gafton@redhat.com>
- turn off PIII patches again
- NFS hang patch fix
- TCP sequence patch fix

* Sat Sep 25 1999 Cristian Gafton <gafton@redhat.com>
- turn off suid bit on cardctl

* Fri Sep 24 1999 Cristian Gafton <gafton@redhat.com>
- add bestfunc patch to PIII patches and re-enable them

* Fri Sep 24 1999 Cristian Gafton <gafton@redhat.com>
- disable PIII patches
- 2.2.13pre12
- PIII patches from Doug
- network fixes form DaveM
- sparc patches integration and consolidatin with stuff from vger (DaveM)
- put back the nfsd patches from earlier versions

* Tue Sep 21 1999 Cristian Gafton <gafton@redhat.com>
- 2.2.13pre11
- patch from Jakub to make CONFIG_BINFMT_SUNOS configurable on the sparc

* Mon Sep 20 1999 Doug Ledford <dledford@redhat.com>
- Integrated the PIII patch and the PIII-xor patch against Ingo's raid code
- Updated config files for PIII support
- Added Vesa FB support to the i386-BOOT config

* Thu Sep 16 1999 Cristian Gafton <gafton@redhat.com>
- 2.2.13pre9
- fix the Provides for the smp and BOOT kernel packages (provide the current
  version)
- alpha patches from Jay Estabrook
- Ingo's updated RAID code

* Mon Sep 13 1999 Cristian Gafton <gafton@redhat.com>
- jump to 2.2.13pre7 from Alan
- remove Ingo's raid patch to see if we gain more stability
- leave the peerbus patch enabled only for intel builds as it breaks alpha
  and sparc

* Sat Sep 11 1999 Cristian Gafton <gafton@redhat.com>
- use getconf to get the number opf CPus on the machine for use in the
  build process
- add DaveM's sparc and strlen_user() fix

* Fri Sep 10 1999 Doug Ledford <dledford@redhat.com>
- Add another device to the pci id listings
- Fix a one line bug in pcnet32.c

* Wed Sep 08 1999 Cristian Gafton <gafton@redhat.com>
- new ipvs patch
- patch from Doug to deal with peer PCI patch

* Tue Sep 07 1999 Cristian Gafton <gafton@redhat.com>
- patch from DaveM to handle increased NR_TASKS on sun4c
- build an alpha SMP BOOT kernel.
- don't ship sparc64 binaries on Intel

* Mon Sep 06 1999 Doug Ledford <dledford@redhat.com>
- add pci-id patch to correct pci.h and oldproc.c bugs
- add aic7xxx-5.1.20 patch to fix two kernel null pointer derefs
- very small patch to fix problems on Intel 450NX chipset motherboards
  (this is a preliminary patch pending an official patch from Martin Mares)

* Fri Sep 03 1999 Cristian Gafton <gafton@redhat.com>
- add hashing patch from DaveM
- add peerpci patch from Doug (disabled because it is busted)

* Thu Sep 02 1999 Cristian Gafton <gafton@redhat.com>
- add APIC patch from Doug and Zach

* Tue Aug 31 1999 Cristian Gafton <gafton@redhat.com>
- added Alan's fixes patch
- added rawio patch from Stephen
- disabled CONFIG_SCSI_ALL_LUN on all config files

* Sun Aug 29 1999 Cristian Gafton <gafton@redhat.com>
- 2.2.12
- enabled IPVS
- work around rpm's stupidity when it comes to _arch/_target_cpu and
  sparc/sparc64

* Wed Aug 25 1999 Cristian Gafton <gafton@redhat.com>
- add the linux/modversions.h file to the list of kernel version dependent
  (because of the .ver files it includes)
- upgrade to final3 + add-on patches

* Mon Aug 16 1999 Cristian Gafton <gafton@redhat.com>
- added pre7 patches from 2.2.12
- handle kernel-version specific autoconf.h and version.h headers
- add the NFS patches

* Fri Aug 13 1999 Cristian Gafton <gafton@redhat.com>
- add the serveraid patch

* Fri Aug 06 1999 Cristian Gafton <gafton@redhat.com>
- updated to pre5
- updated RAID patch from Ingo

* Mon Jul 26 1999 Cristian Gafton <gafton@redhat.com>
- patch to address the sysrq error on sparc
- patch to fix socket include file (thanks notting)
- add sparc patch from Jakub
- add afinet patch from Alexey Kuznetov
- add 2GB patch from Leonard Zubkoff

* Thu Jul 15 1999 Cristian Gafton <gafton@redhat.com>
- updated Adaptec kernel driver to 5.1.18
- pcmcia 3.0.13
- patch to pcmcia to fix some Cardbus problems

* Wed Jul 14 1999 Cristian Gafton <gafton@redhat.com>
- add patch to fix ATAPI ZIP drives

* Mon Jun 28 1999 Cristian Gafton <gafton@redhat.com>
- adeed patch tp increase default SEMMSL value

* Mon Jun 14 1999 Bill Nottingham <notting@redhat.com>
- turn off CONFIG_SMB_WIN95

* Tue Jun  1 1999 Matt Wilson <msw@redhat.com>
- added remote crash fix from Alan Cox

* Mon May 17 1999 Matt Wilson <msw@redhat.com>
- rebuilt against fixed egcs to fix sparc crashes

* Mon Apr 26 1999 Cristian Gafton <gafton@redhat.com>
- alpha patches form Jay Estabrook
- semaphore patches from rth for alpha

* Mon Apr 19 1999 Cristian Gafton <gafton@redhat.com>
- upgraded the defrag patch with stuff from davem

* Sun Apr 18 1999 Cristian Gafton <gafton@redhat.com>
- log debugging information about starting nfsd to syslog instead of console
- make sure the postinstall exits with success for the kernel rpm if lilo
  has issues
- updated sparc jumbo patch
- networking fixes from DaveM
- make pcmcia use a preun instead of a postun. Duh.
- triggerpostun protects upgrades from older verrsions of pcmcia. Duh. Duh.

* Sat Apr 17 1999 Cristian Gafton <gafton@redhat.com>
- added patches for the alpha problems, ftruncate fix, mmap
  and shm fixes from the 2.2.6 kernel
- updated DaveM's sparc patch
- x86 patches also from x86 kernel

* Fri Apr 16 1999 Cristian Gafton <gafton@redhat.com>
- build alpha network drivers as modules
- pcmcia scripts do not use /dev/cuaX anymore for /dev/modem (ttySX instead)
- disable RTC on alpha

* Wed Apr 14 1999 Cristian Gafton <gafton@redhat.com>
- add patch for tokenring
- add the REAME.kernel-sources file to the kernel-headers
- updated again the sparc patch
- add Linus's patch to fix out of memory errors
- fix dac960's driver include files

* Mon Apr 12 1999 Cristian Gafton <gafton@redhat.com>
- new sparc patch (davem)
- new RAID patch (mingo)
- new aic7xxx driver (5.1.15 - dledford)
- aarp patch from alan

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- add patch from Alan to make SYS_access SuSv2 compliant
- update Dave Miller's sparc patch
- get rid of the bogus buffer patch (why the heck didn't patch reject it in
  first place?)

* Wed Apr 07 1999 Cristian Gafton <gafton@redhat.com>
- more patches from Alan
- updated the knfsd patches from knfsd 1.2.2

* Mon Apr 05 1999 Cristian Gafton <gafton@redhat.com>
- updated sparc patch from davem
- added patch for sound docs and bttv driver from alan

* Wed Mar 31 1999 Cristian Gafton <gafton@redhat.com>
- add i586 as an other platform
- patch from Alan Cox to fix misc hangups
- updated Doug's driver to 5.1.13
- version 2.2.5

* Fri Mar 26 1999 Cristian Gafton <gafton@redhat.com>
- added BOOT config files for all the arches
- updated config files (again)

* Wed Mar 24 1999 Cristian Gafton <gafton@redhat.com>
- version 2.2.4
- new DAC960 patch
- install a module-info for ech kernel build
- be more selective in building kernel-doc for all arches
- alpha CPUs detection patch

* Sat Mar 13 1999 Cristian Gafton <gafton@redhat.com>
- patch for nbd stuff
- added large fd patch
- added nfsd patches from the knfsd dist

* Sat Mar 13 1999 Matt Wilson <msw@redhat.com>
- disabled vfork() on sparc32
- fixed up sparc64 build
- changed the compression level for bzImages from -9 to -3 on i386

* Fri Mar 12 1999 Matt Wilson <msw@redhat.com>
- build sunlance into the sparc kernels

* Thu Mar 11 1999 Cristian Gafton <gafton@redhat.com>
- version 2.2.3
- make the /usr/src/linux-VER dir owned by kernel-headers instead of
  kernel-source

* Wed Mar 10 1999 Cristian Gafton <gafton@redhat.com>
- update to 2.2.2-ac7
- add config files for i686

* Wed Feb 24 1999 Cristian Gafton <gafton@redhat.com>
- merged in sparc64 changes
- update to 2.2.2
- fix the uname problems in different shapes of kernel being generated
- create a documentation package

* Thu Feb 11 1999 Cristian Gafton <gafton@redhat.com>
- version 2.2.1 w/ ac5
- build the boot kernel for the bootdisks

* Wed Jan 27 1999 Cristian Gafton <gafton@redhat.com>
- ver 2.2.0 final w/ ac1
- move the pcmcia modules to the main kernel package
- also build smp version of the kernel
- enable apm in the kernel by default

* Tue Jan 19 1999 Cristian Gafton <gafton@redhat.com>
- update to 2.2.0 pre 8 w/ ac1

* Sun Dec 27 1998 Mike Wangsmo <wanger@redhat.com>
- put in 133ac3
- fixed PCMCIA to use GET_USE_COUNT instead of module->usecount

* Mon Dec 21 1998 Cristian Gafton <gafton@redhat.com>
- remove the jensen and srm-jensen subpackages, as those should be handled
  by the generic kernel instead.
- use 131ac13
- upgradede to 2.1.131
- removed /usr/include/scsi from kernel-headers

* Mon Nov 23 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 2.1.129 ac3
- pcmcia-cs 3.0.6
- XXX: disabled the DEPCS, EWRK3 support, as it does not build yet

* Tue Sep 29 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 2.1.123
- builds jansen and jensen-srm subpackages on alpha

* Thu Aug 13 1998 Cristian Gafton <gafton@redhat.com>
- build of 2.1.115, based on the previous spec from 2.0.35
- build like almost any other package, not dircetly in the buildroot
- sed the buildroot dir out of the .depend files

